# -*- ecoding: utf-8 -*-
# @ModuleName: proxy_utils.py
# @Function:
# @Author: 安辉
# @Time: 2021/11/17 15:00

import sys

sys.path.append('../')

import time
import re
import random
from base64 import urlsafe_b64encode
from utils.redis_utils import redis_db3_conn, redis_db0_conn

CITY_IP_CONFIG = {
    '池州': ['2001', '2002', '2003', '2004', '2005', '2006', '2007', '2008', '2009', '2010'],
    '黄冈': ['2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020'],
    '扬州': ['2021', '2022', '2023', '2024', '2025', '2026', '2027', '2028', '2029', '2030'],
    '吉安': ['2031', '2032', '2033', '2034', '2035', '2036', '2037', '2038', '2039', '2040'],
    '九江': ['2041', '2042', '2043', '2044', '2045', '2046', '2047', '2048', '2049', '2050'],
    '芜湖': ['2051', '2052', '2053', '2054', '2055', '2056', '2057', '2058', '2059', '2060'],
    '鹰潭': ['2061', '2062', '2063', '2064', '2065', '2066', '2067', '2068', '2069', '2070'],
    '丽水': ['2071', '2072', '2073', '2074', '2075', '2076', '2077', '2078', '2079', '2080'],
    '台州': ['2081', '2082', '2083', '2084', '2085', '2086', '2087', '2088', '2089', '2090'],
    '绍兴': ['2091', '2092', '2093', '2094', '2095', '2096', '2097', '2098', '2099', '2100'],
}


def fetch_proxy_by_service(source='all'):
    '''
    通过第三方服务拿到代理
    :return:
    '''
    # 阿布云
    abuyun_proxy_list = [
        'http://H60X43R32773Q47P:6740785F761EB814@http-pro.abuyun.com:9010',
        'http://H8EYV13W48Y3BUXP:F5E9A0031C2682C0@http-pro.abuyun.com:9010',
        'http://H52HS5328ICQ017P:6EBF9D1757F23D2E@http-pro.abuyun.com:9010',
        'http://H670P7BTG7436H4P:EE57DA5267877D78@http-pro.abuyun.com:9010',
    ]
    # 多贝云
    duobei_proxy_list = [
        'http://RYNETHTT3:gL0I092UHjf@http-proxy-t1.dobel.cn:9180',
        'http://RYNETHTT4:gL0I092UHjf@http-proxy-t1.dobel.cn:9180',
        'http://RYNETHTT5:gL0I092UHjf@http-proxy-t1.dobel.cn:9180',
        'http://RYNETHTT6:gL0I092UHjf@http-proxy-t1.dobel.cn:9180',
        # 'http://RYNETHTT7:gL0I092UHjf@http-proxy-t1.dobel.cn:9180', 逆向占用
    ]
    if source == 'duobei':
        proxy_list = duobei_proxy_list
    elif source == 'abuyun':
        proxy_list = abuyun_proxy_list
    else:
        proxy_list = abuyun_proxy_list + duobei_proxy_list

    proxy = random.choice(proxy_list)
    r = redis_db0_conn
    user, password, host = re.search('http://(\w+):(\w+)@(.*)', proxy).groups()
    proxy = f'http://{host}'
    proxyAuth = 'Basic ' + urlsafe_b64encode(bytes((user + ':' + password), 'ascii')).decode('utf8')
    full_proxy = f'http://{user}:{password}@{host}'
    real_ip = r.get_real_ip(full_proxy)
    proxy_request_format = {
        'http': full_proxy,
        'https': full_proxy
    }
    return proxy, real_ip, proxyAuth, proxy_request_format


last_fetch_time = 0
ip_list = []


def fetch_proxy_by_vps(city=''):
    '''
    通过vps获取代理IP
    :return:
    '''
    global last_fetch_time, ip_list

    current_ts = time.time()
    fetch_interval = 10

    redis_key = 'proxies_clean'
    user = 'xzszlz'
    password = 'Lsjkcbdjz666'
    port = 18119

    if current_ts - last_fetch_time > fetch_interval:
        r = redis_db3_conn
        last_fetch_time = current_ts
        ip_list = r.redis_hvals(redis_key)

    # if city in CITY_IP_CONFIG:
    #     ip_id = random.choice(CITY_IP_CONFIG[city])
    #     real_ip = r.redis_hget(redis_key, ip_id)
    # else:
    real_ip = random.choice(ip_list)

    if isinstance(real_ip, bytes):
        real_ip = real_ip.decode()

    proxy = f'http://{real_ip}:{port}'
    proxyAuth = 'Basic ' + urlsafe_b64encode(bytes((user + ':' + password), 'ascii')).decode('utf8')
    full_proxy = f'http://{user}:{password}@{password}'
    proxy_request_format = {
        'http://': full_proxy,
        'https://': full_proxy
    }
    return proxy, real_ip, proxyAuth, proxy_request_format
